curl --request POST \
--url https://hip4-api.totalis.trade/v1/me/deposits \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"schema_version": 1,
"request_id": "0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40",
"sent_at": "2026-10-16T12:10:00Z",
"command": {
"account": "0x1111111111111111111111111111111111111111",
"from": "0x1111111111111111111111111111111111111111",
"value": "5000000",
"valid_after": "1792152000",
"valid_before": "1792152600",
"salt": "0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a",
"authorization_signature": "0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab"
}
}
'import requests
url = "https://hip4-api.totalis.trade/v1/me/deposits"
payload = {
"schema_version": 1,
"request_id": "0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40",
"sent_at": "2026-10-16T12:10:00Z",
"command": {
"account": "0x1111111111111111111111111111111111111111",
"from": "0x1111111111111111111111111111111111111111",
"value": "5000000",
"valid_after": "1792152000",
"valid_before": "1792152600",
"salt": "0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a",
"authorization_signature": "0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab"
}
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
schema_version: 1,
request_id: '0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40',
sent_at: '2026-10-16T12:10:00Z',
command: {
account: '0x1111111111111111111111111111111111111111',
from: '0x1111111111111111111111111111111111111111',
value: '5000000',
valid_after: '1792152000',
valid_before: '1792152600',
salt: '0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a',
authorization_signature: '0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab'
}
})
};
fetch('https://hip4-api.totalis.trade/v1/me/deposits', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://hip4-api.totalis.trade/v1/me/deposits",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'schema_version' => 1,
'request_id' => '0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40',
'sent_at' => '2026-10-16T12:10:00Z',
'command' => [
'account' => '0x1111111111111111111111111111111111111111',
'from' => '0x1111111111111111111111111111111111111111',
'value' => '5000000',
'valid_after' => '1792152000',
'valid_before' => '1792152600',
'salt' => '0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a',
'authorization_signature' => '0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://hip4-api.totalis.trade/v1/me/deposits"
payload := strings.NewReader("{\n \"schema_version\": 1,\n \"request_id\": \"0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40\",\n \"sent_at\": \"2026-10-16T12:10:00Z\",\n \"command\": {\n \"account\": \"0x1111111111111111111111111111111111111111\",\n \"from\": \"0x1111111111111111111111111111111111111111\",\n \"value\": \"5000000\",\n \"valid_after\": \"1792152000\",\n \"valid_before\": \"1792152600\",\n \"salt\": \"0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a\",\n \"authorization_signature\": \"0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab\"\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://hip4-api.totalis.trade/v1/me/deposits")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"schema_version\": 1,\n \"request_id\": \"0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40\",\n \"sent_at\": \"2026-10-16T12:10:00Z\",\n \"command\": {\n \"account\": \"0x1111111111111111111111111111111111111111\",\n \"from\": \"0x1111111111111111111111111111111111111111\",\n \"value\": \"5000000\",\n \"valid_after\": \"1792152000\",\n \"valid_before\": \"1792152600\",\n \"salt\": \"0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a\",\n \"authorization_signature\": \"0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab\"\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://hip4-api.totalis.trade/v1/me/deposits")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"schema_version\": 1,\n \"request_id\": \"0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40\",\n \"sent_at\": \"2026-10-16T12:10:00Z\",\n \"command\": {\n \"account\": \"0x1111111111111111111111111111111111111111\",\n \"from\": \"0x1111111111111111111111111111111111111111\",\n \"value\": \"5000000\",\n \"valid_after\": \"1792152000\",\n \"valid_before\": \"1792152600\",\n \"salt\": \"0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a\",\n \"authorization_signature\": \"0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab\"\n }\n}"
response = http.request(request)
puts response.read_body{
"operation_id": "0x3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c",
"state": "DURABLE",
"amount": "5000000"
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}Create deposit
Moves USDC from the account wallet into its Totalis vault balance with a signed USDC ReceiveWithAuthorization that Totalis relays and pays the gas for.
Requires a wallet session, sent from its Origin; an API key cannot call it.
curl --request POST \
--url https://hip4-api.totalis.trade/v1/me/deposits \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"schema_version": 1,
"request_id": "0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40",
"sent_at": "2026-10-16T12:10:00Z",
"command": {
"account": "0x1111111111111111111111111111111111111111",
"from": "0x1111111111111111111111111111111111111111",
"value": "5000000",
"valid_after": "1792152000",
"valid_before": "1792152600",
"salt": "0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a",
"authorization_signature": "0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab"
}
}
'import requests
url = "https://hip4-api.totalis.trade/v1/me/deposits"
payload = {
"schema_version": 1,
"request_id": "0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40",
"sent_at": "2026-10-16T12:10:00Z",
"command": {
"account": "0x1111111111111111111111111111111111111111",
"from": "0x1111111111111111111111111111111111111111",
"value": "5000000",
"valid_after": "1792152000",
"valid_before": "1792152600",
"salt": "0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a",
"authorization_signature": "0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab"
}
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
schema_version: 1,
request_id: '0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40',
sent_at: '2026-10-16T12:10:00Z',
command: {
account: '0x1111111111111111111111111111111111111111',
from: '0x1111111111111111111111111111111111111111',
value: '5000000',
valid_after: '1792152000',
valid_before: '1792152600',
salt: '0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a',
authorization_signature: '0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab'
}
})
};
fetch('https://hip4-api.totalis.trade/v1/me/deposits', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://hip4-api.totalis.trade/v1/me/deposits",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'schema_version' => 1,
'request_id' => '0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40',
'sent_at' => '2026-10-16T12:10:00Z',
'command' => [
'account' => '0x1111111111111111111111111111111111111111',
'from' => '0x1111111111111111111111111111111111111111',
'value' => '5000000',
'valid_after' => '1792152000',
'valid_before' => '1792152600',
'salt' => '0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a',
'authorization_signature' => '0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab'
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://hip4-api.totalis.trade/v1/me/deposits"
payload := strings.NewReader("{\n \"schema_version\": 1,\n \"request_id\": \"0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40\",\n \"sent_at\": \"2026-10-16T12:10:00Z\",\n \"command\": {\n \"account\": \"0x1111111111111111111111111111111111111111\",\n \"from\": \"0x1111111111111111111111111111111111111111\",\n \"value\": \"5000000\",\n \"valid_after\": \"1792152000\",\n \"valid_before\": \"1792152600\",\n \"salt\": \"0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a\",\n \"authorization_signature\": \"0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab\"\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://hip4-api.totalis.trade/v1/me/deposits")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"schema_version\": 1,\n \"request_id\": \"0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40\",\n \"sent_at\": \"2026-10-16T12:10:00Z\",\n \"command\": {\n \"account\": \"0x1111111111111111111111111111111111111111\",\n \"from\": \"0x1111111111111111111111111111111111111111\",\n \"value\": \"5000000\",\n \"valid_after\": \"1792152000\",\n \"valid_before\": \"1792152600\",\n \"salt\": \"0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a\",\n \"authorization_signature\": \"0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab\"\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://hip4-api.totalis.trade/v1/me/deposits")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"schema_version\": 1,\n \"request_id\": \"0199a1b2-c3d4-7e5f-8a6b-7c8d9e0f1a40\",\n \"sent_at\": \"2026-10-16T12:10:00Z\",\n \"command\": {\n \"account\": \"0x1111111111111111111111111111111111111111\",\n \"from\": \"0x1111111111111111111111111111111111111111\",\n \"value\": \"5000000\",\n \"valid_after\": \"1792152000\",\n \"valid_before\": \"1792152600\",\n \"salt\": \"0x5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a5a\",\n \"authorization_signature\": \"0xababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababababab\"\n }\n}"
response = http.request(request)
puts response.read_body{
"operation_id": "0x3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c3c",
"state": "DURABLE",
"amount": "5000000"
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}{
"error": {
"code": "INVALID_REQUEST",
"field_violations": [
{
"code": "REQUIRED",
"field": "<string>"
}
],
"message": "<string>",
"request_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"retry": "NEVER"
}
}Authorizations
Wallet session: the access_token from POST /v1/auth/wallet-sessions, for a user who brings their own wallet to a partner's web page. It acts for that wallet's account with no scope limit, and is bound to the Origin it signed in from: send exactly one Origin header with that value, or the request is ORIGIN_REQUIRED or UNAUTHENTICATED. It lasts at most 30 days and ends after 7 idle days or at DELETE /v1/auth/wallet-sessions/current.
Headers
Lowercase UUIDv7 naming this command, unique per caller and route. A retry with the same key and body returns the original result; the same key with a different body returns 409 IDEMPOTENCY_KEY_REUSED.
^[0-9a-f]{8}-[0-9a-f]{4}-7[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$Body
Envelope format version; always 1.
Client-generated UUIDv7 for this request, echoed back in error responses.
^[0-9a-f]{8}-[0-9a-f]{4}-7[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$RFC 3339 UTC time the client sent the request, ending in Z, e.g. 2026-09-26T14:30:00Z.
30^[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}([.][0-9]{1,9})?Z$Signed EIP-3009 authorization that moves USDC from the account wallet into the vault; Totalis relays it and pays gas.
Show child attributes
Show child attributes
Response
Admitted, not yet on chain. Follow the operation on the account stream or with GET /v1/me/operations/{operation_id}; the vault balance changes when it commits. A retry with the same Idempotency-Key and body returns the same operation. An account gets at most 5 deposits an hour.
ID of the queued deposit operation; follow it with GET /v1/me/operations/{operation_id}.
^0x[0-9a-f]{64}$Always DURABLE: the deposit is recorded and queued, not yet executed on chain.
Deposit amount in atomic USDC (6 decimals), the authorization value.
39^(0|[1-9][0-9]*)$Was this page helpful?

